spec:
  inputs:
    stage:
      default: images
      description: "Defines the stage where images are being fetched"
    gib_image_base:
      default: "registry.gitlab.com/gitlab-com/gl-security/product-security/gib"
    gib_image_version:
      default: ":latest"
    gib_log_level:
      default: "info"
      description: "Set GIB log level"
      options:
        - panic
        - fatal
        - error
        - warn
        - info
        - debug
        - trace
    dataDir:
      default: "./data"
      description: "Path to an inventory dataDir"
    gitlab_api_token:
      default: ""
      description: "Access token for the GitLab API"
    days_back:
      default: 7
      type: number
      description: "Number of days in the past to lookup for jobs"
---
# Use GIB to fetch requested images from project jobs.
# This component assumes a non-empty dataDir folder ready to be used in input.dataDir.
images_requested:
  stage: $[[ inputs.stage ]]
  image:
    name: $[[ inputs.gib_image_base | expand_vars ]]$[[ inputs.gib_image_version ]]
    entrypoint: [""]
  script:
    - gib images requested
  variables:
    LOGLEVEL: $[[ inputs.gib_log_level ]]
    DATA_DIR_PATH: $[[ inputs.dataDir ]]
    GITLAB_API_TOKEN: $[[ inputs.gitlab_api_token ]]
    DAYS_BACK: $[[ inputs.days_back ]]
  artifacts:
    paths:
      - $[[ inputs.dataDir ]]
  cache:
    - key: dataDir
      paths:
        - $[[ inputs.dataDir ]]
  rules:
    - if: '$GITLAB_API_TOKEN == "" && $GITLAB_PASSWORD == ""'
      when: never
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
